﻿/*
Keybreeze Desktop
Copyright © 2021 Keybreeze LLC

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.If not, see<http://www.gnu.org/licenses/>.
*/

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace KeybreezeMacroEditor
{
    public partial class frmInputBox : Form
    {
        frmEditor frmEditor_instance;
        public frmInputBox(frmEditor parent)
        {
            InitializeComponent();
            frmEditor_instance = parent;
        }

        private void txtVariable_TextChanged(object sender, EventArgs e)
        {
            txtTypeLater.Text = "<type text=\"" + txtVariable.Text + "\">";
        }

        private void btnCancel_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void btnOK_Click(object sender, EventArgs e)
        {
            string pretext = frmEditor_instance.txtMacro.Text.Substring(0, frmEditor_instance.txtMacro.SelectionStart);
            string posttext = frmEditor_instance.txtMacro.Text.Substring(frmEditor_instance.txtMacro.SelectionStart);
            frmEditor_instance.txtMacro.Text = pretext + "<inputbox question=\"" + txtPrompt.Text + "\" variable=\"" + txtVariable.Text + "\">" + posttext;
            frmEditor_instance.txtMacro.Focus();
            this.Close();
        }

        private void frmInputBox_FormClosing(object sender, FormClosingEventArgs e)
        {
            frmEditor_instance.frmInputBox_instance = null;
        }
    }
}
