﻿/*
Keybreeze Desktop
Copyright © 2021 Keybreeze LLC

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.If not, see<http://www.gnu.org/licenses/>.
*/

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace KeybreezeMacroEditor
{
    public partial class frmRecording : Form
    {
        frmMain frmMain_instance;
        public frmRecording(frmMain parent)
        {
            InitializeComponent();
            frmMain_instance = parent;
        }

        private void frmRecording_Load(object sender, EventArgs e)
        {

        }

        private void frmRecording_Shown(object sender, EventArgs e)
        {
            // place form at bottom right corner.
            if (frmMain_instance.recording_mode == 1)
                label1.Text = "Recording in progress. Click box or press " + frmMain_instance.stop_key + " to stop.";
            else
                label1.Text = "Playback in progress. Click box or press " + frmMain_instance.stop_key + " to stop.";
            label1.Visible = true;
            this.Width = label1.Width + 20;
            Rectangle workingArea = Screen.GetWorkingArea(this);
            this.Location = new Point(workingArea.Right - Size.Width, workingArea.Bottom - Size.Height);
            this.Refresh();
        }

        private void label1_MouseDown(object sender, MouseEventArgs e)
        {
            if (frmMain_instance.recording_mode == 1)
                frmMain_instance.StopRecording();
            else
                frmMain_instance.StopPlayback();
        }

        private void frmRecording_MouseDown(object sender, MouseEventArgs e)
        {
            if (frmMain_instance.recording_mode == 1)
                frmMain_instance.StopRecording();
            else
                frmMain_instance.StopPlayback();
        }
    }
}
