﻿/*
Keybreeze Desktop
Copyright © 2021 Keybreeze LLC

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.If not, see<http://www.gnu.org/licenses/>.
*/

using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Net;
using System.IO;
using System.Text;
using System.Diagnostics;

namespace Keybreeze_Update_Check
{
    static class Program
    {
        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        /// 
        public static int version = 570;

        [STAThread]
        static void Main()
        {
            Application.EnableVisualStyles();
            Application.SetCompatibleTextRenderingDefault(false);
            string response = Read_Data_From_Webpage("http://keybreeze.com/update/keybreeze/current_version.html");
            try
            {
                int numeric_version = Convert.ToInt32(response);
                if (numeric_version > version)
                {
                    DialogResult result;
                    result = MessageBox.Show("An update to Keybreeze Desktop is available. Updating is recommended. Do you want to update now?", "Keybreeze Desktop", MessageBoxButtons.YesNo);
                    if (result == DialogResult.Yes)
                    {
                        Process.Start("http://keybreeze.com/download/releasenotes/keybreeze?version=" + version);
                    }
                }
            }
            catch { }
            Application.Exit();
        }

        public static string Read_Data_From_Webpage(string url)
        {
            try
            {
                System.Net.WebClient wc = new System.Net.WebClient();
                byte[] raw = wc.DownloadData(url);
                string webData = System.Text.Encoding.UTF8.GetString(raw);
                return webData;
            }
            catch(Exception ex)
            {
                return "";
            }
        }
    }
}
