﻿/*
Keybreeze Desktop
Copyright © 2021 Keybreeze LLC

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.If not, see<http://www.gnu.org/licenses/>.
*/

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Keybreeze
{
    public partial class frmImportConfirm : Form
    {
        frmImport frmImport_instance = new frmImport();
        public frmImportConfirm(frmImport parent)
        {
            InitializeComponent();
            frmImport_instance = parent;
        }

        private void frmImportConfirm_Load(object sender, EventArgs e)
        {
            
        }

        public void Setup_Columns(DataGridView this_datagridview)
        {
            this_datagridview.ColumnCount = 5;
            this_datagridview.Columns[0].Name = "Name";
            this_datagridview.Columns[1].Name = "Type";
            this_datagridview.Columns[2].Name = "Path";
            this_datagridview.Columns[3].Name = "Target";
            this_datagridview.Columns[4].Name = "Options";
            this_datagridview.Columns[0].Width = 175;
            this_datagridview.Columns[1].Width = 100;
            this_datagridview.Columns[2].Width = 100;
            this_datagridview.Columns[3].Width = 500;
            this_datagridview.Columns[4].Width = 500;
            this_datagridview.RowHeadersWidth = 30;
        }

        private void txtRenameEntry_Enter(object sender, EventArgs e)
        {
            this.AcceptButton = btnRenameEntry;
        }

        private void txtRenamePath_Enter(object sender, EventArgs e)
        {
            this.AcceptButton = btnRenamePath;
        }

        private void btnStopImporting_Click(object sender, EventArgs e)
        {
            frmImport_instance.if_exists_do_this = "stop";
            this.Close();
        }

        private void btnRenameEntry_Click(object sender, EventArgs e)
        {
            if (txtRenameEntry.Text == "")
                txtRenameEntry.Focus();
            else
            {
                // they want to rename the new entry to something else.
                // first let's make sure the new name is not in use.
                string this_keyword = txtRenameEntry.Text;
                string this_path = dataGridView1.Rows[0].Cells[2].Value.ToString();
                foreach (Keyword existing_keyword in Globals.Keyword_List)
                {
                    if (existing_keyword.name.ToLower() == this_keyword.ToLower() && existing_keyword.path.ToLower() == this_path.ToLower())
                    {
                        MessageBox.Show("A keyword with that name already exists. Please choose a different name.", "Keybreeze Desktop");
                        return;
                    }
                }
                frmImport_instance.if_exists_do_this = "rename_new_entry";
                frmImport_instance.if_exists_replace_with = txtRenameEntry.Text;
                this.Close();
            }
        }

        private void btnRenamePath_Click(object sender, EventArgs e)
        {
            if (txtRenamePath.Text == "")
                txtRenamePath.Focus();
            else
            {
                // they want to rename the new path to something else.
                // first let's make sure the new name is not in use.
                string this_keyword = dataGridView1.Rows[0].Cells[0].Value.ToString();
                string this_path = txtRenamePath.Text;
                foreach (Keyword existing_keyword in Globals.Keyword_List)
                {
                    if (existing_keyword.name.ToLower() == this_keyword.ToLower() && existing_keyword.path.ToLower() == this_path.ToLower())
                    {
                        MessageBox.Show("A keyword with that name and path already exists. Please choose a different name.", "Keybreeze Desktop");
                        return;
                    }
                }
                frmImport_instance.if_exists_do_this = "rename_new_path";
                frmImport_instance.if_exists_replace_with = txtRenamePath.Text;
                this.Close();
            }
        }

        private void btnSkip_Click(object sender, EventArgs e)
        {
            frmImport_instance.if_exists_do_this = "skip";
            this.Close();
        }

        private void btnReplaceExisting_Click(object sender, EventArgs e)
        {
            frmImport_instance.if_exists_do_this = "replace_existing";
            this.Close();
        }
    }
}
