﻿/*
Keybreeze Desktop
Copyright © 2021 Keybreeze LLC

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.If not, see<http://www.gnu.org/licenses/>.
*/

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Keybreeze
{
    public partial class frmOptions_Extra : Form
    {
        public int option_referencing;
        frmOptions frmOptions_instance;
        frmMain frmMain_instance;
        public frmOptions_Extra(frmOptions parent, frmMain main_parent)
        {
            InitializeComponent();
            frmOptions_instance = parent;
            frmMain_instance = main_parent;
        }

        private void frmOptions_Extra_Load(object sender, EventArgs e)
        {

        }

        private void button1_Click(object sender, EventArgs e)
        {
            openFD.ShowDialog();
            txtTarget.Text = openFD.FileName;
        }

        private void cmdOK_Click(object sender, EventArgs e)
        {
            if (Globals.DoesFileExist(txtTarget.Text) == false)
            {
                MessageBox.Show("The file does not exist at that path. Please check the location.", "Keybreeze Desktop");
                return;
            }
            if (option_referencing == 1)
            {
                Globals.WriteINI("options", "default_browser", "0", Globals.OptionsINI);
                Globals.WriteINI("options", "custom_browser_path", txtTarget.Text, Globals.OptionsINI);
                Globals.WriteINI("options", "custom_browser_prefix", txtPrefix.Text, Globals.OptionsINI);
                Globals.WriteINI("options", "custom_browser_suffix", txtSuffix.Text, Globals.OptionsINI);
                frmMain_instance.custom_browser_path = txtTarget.Text;
                frmMain_instance.custom_browser_prefix = txtPrefix.Text;
                frmMain_instance.custom_browser_suffix = txtSuffix.Text;
            }
            else if (option_referencing == 2)
            {
                Globals.WriteINI("options", "windows_explorer", "0", Globals.OptionsINI);
                Globals.WriteINI("options", "custom_explorer_path", txtTarget.Text, Globals.OptionsINI);
                Globals.WriteINI("options", "custom_explorer_prefix", txtPrefix.Text, Globals.OptionsINI);
                Globals.WriteINI("options", "custom_explorer_suffix", txtSuffix.Text, Globals.OptionsINI);
            }
            this.Close();
        }

        private void cmdCancel_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void frmOptions_Extra_FormClosing(object sender, FormClosingEventArgs e)
        {
            if (option_referencing == 1)
            {
                // browser setting.
                if (Globals.ReadINI("options", "default_browser", Globals.OptionsINI) == "0")
                {
                    // the user selected a custom browser.
                    frmOptions_instance.chkDefaultWebBrowser.Checked = false;
                    frmOptions_instance.edit_settings_1.Visible = true;
                }
                else
                {
                    // the user is using the default browser.
                    frmOptions_instance.chkDefaultWebBrowser.Checked = true;
                    frmOptions_instance.edit_settings_1.Visible = false;
                }
            }
            else if (option_referencing == 2)
            {
                // windows explorer setting.
                if (Globals.ReadINI("options", "windows_explorer", Globals.OptionsINI) == "0")
                {
                    // the user selected a custom browser.
                    frmOptions_instance.chkWindowsExplorer.Checked = false;
                    frmOptions_instance.edit_settings_2.Visible = true;
                }
                else
                {
                    // the user is using the default browser.
                    frmOptions_instance.chkWindowsExplorer.Checked = true;
                    frmOptions_instance.edit_settings_2.Visible = false;
                }
            }
            frmOptions_instance.Enabled = true;
        }
    }
}
