﻿/*
Keybreeze Desktop
Copyright © 2021 Keybreeze LLC

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.If not, see<http://www.gnu.org/licenses/>.
*/

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace Keybreeze
{
    public partial class frmOptions_Extra2 : Form
    {
        bool changed_list = false;
        frmOptions frmOptions_instance;
        public frmOptions_Extra2(frmOptions parent)
        {
            InitializeComponent();
            frmOptions_instance = parent;
        }

        private void button2_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void frmOptions_Extra2_Load(object sender, EventArgs e)
        {
            if (this.Text == "Autocomplete list")
            {
                // load autocomplete items into the listbox.
                foreach (string entry in Globals.autocomplete_list)
                {
                    listBox1.Items.Add(entry);
                }
                listBox1.SelectedIndex = 0;
            }
            else if (this.Text == "Items in history")
            {
                foreach (History this_history_item in Globals.History_List)
                {
                    listBox1.Items.Add(this_history_item.e);
                }
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            try
            {
                listBox1.Items.RemoveAt(listBox1.SelectedIndex);
                Globals.History_List.RemoveAt(listBox1.SelectedIndex);
                Globals.History_Save_To_File();
                changed_list = true;
            }
            catch
            {
            }
        }

        private void frmOptions_Extra2_FormClosing(object sender, FormClosingEventArgs e)
        {
            frmOptions_instance.Enabled = true;
            if (changed_list == true)
            {
                if (this.Text == "Autocomplete list")
                {
                    // save the list to the autocomplete list and the autocomplete file.
                    string piped_entries = "";
                    Globals.autocomplete_list.Clear();
                    foreach (string listitem in listBox1.Items)
                    {
                        Globals.autocomplete_list.Add(listitem);
                        piped_entries = piped_entries + listitem + "|";
                    }
                    string AutoCompleteFile = Globals.WorkPath + "\\autocomplete.txt";
                    try
                    {
                        System.IO.File.WriteAllText(AutoCompleteFile, piped_entries, Encoding.Unicode);
                    }
                    catch
                    {
                        MessageBox.Show("The autocomplete file could be saved to " + AutoCompleteFile + ". Please check your windows permissions for this directory.", "Keybreeze Desktop");
                    }
                }
            }
        }
    }
}
